/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 14.10.2010
Author  : AZM.SU
Company : Zerro
Comments: 


Chip type               : ATtiny13
AVR Core Clock frequency: 9,600000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 16



ADC3 (PIN 2)            IN Ch0 (0...V+)
ADC2 (PIN 3)            IN Ch1 (0...V+)
PB2 (PIN 7)             OUT PWM Ch0 (640kHz 5bit pwm: 0...31)
PB1 (PIN 3)             OUT PWM Ch1 (640kHz 5bit pwm: 0...31)



*****************************************************/

#include <tiny13.h>

#include <delay.h>


unsigned char INadc0=0;
unsigned char INadc1=0;
unsigned char OUpwm0=0;
unsigned char OUpwm1=0;
unsigned char CNTpwm=0;


// Timer 0 output compare A interrupt service routine
interrupt [TIM0_COMPA] void timer0_compa_isr(void){
if (CNTpwm == OUpwm0){PORTB.1=0;}
if (CNTpwm == OUpwm1){PORTB.2=0;}

CNTpwm=CNTpwm+1;
if (CNTpwm ==32){
CNTpwm=0;
OUpwm0=INadc0;
OUpwm1=INadc1;
if (OUpwm0 != 0){PORTB.1=1;}
if (OUpwm1 != 0){PORTB.2=1;}
}

} // interrupt [TIM0_COMPA] void timer0_compa_isr(void)


#define ADC_VREF_TYPE 0x20

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=In 
// State5=T State4=T State3=T State2=0 State1=0 State0=T 
PORTB=0x00;
DDRB=0x06;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 9600,000 kHz
// Mode: CTC top=OCR0A
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x02;
TCCR0B=0x01;
TCNT0=0x00;
OCR0A=15;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x04;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// ADC initialization
// ADC Clock frequency: 600,000 kHz
// ADC Bandgap Voltage Reference: Off
// ADC Auto Trigger Source: None
// Only the 8 most significant bits of
// the AD conversion result are used
// Digital input buffers on ADC0: On, ADC1: On, ADC2: Off, ADC3: Off
DIDR0&=0x03;
DIDR0|=0x18;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x84;

// Global enable interrupts
#asm("sei")

while (1){

INadc0=read_adc(3) >> 3;
INadc1=read_adc(2) >> 3;

}; // while (1)



}
